\name{olive}
\alias{olive}
\docType{data}
\title{Italian Olive Oil}
\description{
Data on the percentage composition of eight fatty acids found by lipid fraction of 572 Italian olive oils. The data come from three regions: Southern Italy, Sardinia, and Northern Italy. Within each region there are a number of different areas. Southern Italy comprises North Apulia, Calabria, South Apulia, and Sicily. Sardinia is divided into Inland Sardinia and Costal Sardinia. Northern Italy comprises Umbria, East Liguria, and West Liguria. 
}
\usage{data(olive)}
\format{
  A data frame with 572 observations and 10 columns. The first column gives the region: (\code{1}) Southern Italy, (\code{2}) Sardinia, or (\code{3}) Northern Italy. The second column gives the area: (\code{1}) North Apulia, (\code{2}) Calabria, (\code{3}) South Apulia, (\code{4}) Sicily, (\code{5}) Inland Sardinia, (\code{6}) Costal Sardinia, (\code{7}) East Liguria, (\code{8}) West Liguria, and (\code{9}) Umbria. The other eight columns contain the variables.
}
%\details{
%%  ~~ If necessary, more details than the __description__ above ~~
%}
\source{
These data are available within the GGobi software (Swayne et al., 2006).
}
\references{
Forina, M., Armanino, C., Lanteri, S. and Tiscornia, E. (1983). Classification of olive oils from their fatty acid composition. In \emph{Food Research and Data Analysis}, pp. 189--214. Applied Science Publishers, London.

Forina, M. and Tiscornia, E. (1982). Pattern recognition methods in the prediction of {I}talian olive oil origin by their fatty acid content. \emph{Annali di Chimica} \bold{72}, 143--155.

Swayne, D.F., Cook, D., Buja, A., Lang, D.T., Wickham, H. and Lawrence, M. (2006). \emph{GGobi Manual}. Sourced from www.ggobi.org/docs/manual.pdf.
}
\keyword{datasets}
